﻿
Imports System.Runtime.InteropServices

Public Class Form1
    ' For Dll Start
	'	Board Type
    Private Const AW_TYPE_AP4801 As UInt16 = &H0020
    Private Const AW_TYPE_AP4802 As UInt16 = &H0021

	'	Read/Write/Size
	Private Const FLG_READ As UInteger = &H00000000
	Private Const FLG_WRITE As UInteger = &H00000001
	Private Const FLG_READ_WRITE_MASK As UInteger = &H00000001

	Private Const FLG_BYTE As UInteger = &H00000000
	Private Const FLG_WORD As UInteger = &H00000002
	Private Const FLG_BYTE_WORD_MASK As UInteger = &H00000002

	Private Const FLG_READ_BYTE As UInteger = FLG_READ Or FLG_BYTE
	Private Const FLG_WRITE_BYTE As UInteger = FLG_WRITE Or FLG_BYTE
	Private Const FLG_READ_WORD As UInteger = FLG_READ Or FLG_WORD
	Private Const FLG_WRITE_WORD As UInteger = FLG_WRITE Or FLG_WORD

	'   Structure  AW_DEVICE_LIST
    Public Structure AW_DEVICE_INFO
        Public BoardNo As UInt16
        Public BoardType As UInt16
        Public MemSize As UInt32
    End Structure
    Public Structure AW_DEVICE_LIST
        Public BoardCount As UInt32
        Public DeviceInfo() As AW_DEVICE_INFO
    End Structure
    '   GetDeviceInfo
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_GetDeviceInfo(ByRef AwDeviceList As AW_DEVICE_LIST) As Integer
    End Function

    '   GetBoardCount
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_GetBoardCount(ByRef BoardCount As UInt32) As Integer
    End Function

    '   Get1DeviceInfo
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_Get1DeviceInfo(ByVal BoardNo As UInt16, ByRef BoardType As UInt16, ByRef MemSize As UInt32) As Integer
    End Function

    '   Read Byte
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_ReadByte(ByVal BoardNo As Integer, ByVal Address As UInteger, ByRef ByteData As Byte) As Integer
    End Function

    '   Read Word
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_ReadWord(ByVal BoardNo As Integer, ByVal Address As UInteger, ByRef WordData As UInt16) As Integer
    End Function

    '   Write Byte
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_WriteByte(ByVal BoardNo As Integer, ByVal Address As UInteger, ByVal ByteData As Byte) As Integer
    End Function

    '   Write Word
    <DllImport("AW_DB_A40_PCI.dll", CallingConvention:=CallingConvention.Cdecl)> Private Shared Function _
        AW_WriteWord(ByVal BoardNo As Integer, ByVal Address As UInteger, ByVal WordData As UInt16) As Integer
    End Function
    ' For Dll End

    Public gDeviceList As AW_DEVICE_LIST
	Public gBoardNo As Integer
	Public gAddress As UInteger
	Public gBData As Byte
	Public gWData As UInt16
	Public gRet As Integer


    ' button GetDeviceInfo
    Private Sub btnGetDeviceInfo_Click(sender As System.Object, e As System.EventArgs) Handles btnGetDeviceInfo.Click
        Dim InfoIdx As UInt16
        Dim BoardType As UInt16
        Dim MemSize As UInt32

        If AW_GetBoardCount(gDeviceList.BoardCount) < 0 Then             ' Get BoardCount
            Exit Sub
        End If

        If gDeviceList.BoardCount = 0 Then
            Exit Sub
        End If

        ReDim gDeviceList.DeviceInfo(gDeviceList.BoardCount - 1)          ' Get DeviceInfo Area

        InfoIdx = 0
        For i As UInt16 = 0 To 16 - 1
            If AW_Get1DeviceInfo(i, BoardType, MemSize) < 0 Then
                Exit Sub
            End If
            If BoardType = AW_TYPE_AP4801 Or BoardType = AW_TYPE_AP4802 Then
                gDeviceList.DeviceInfo(InfoIdx).BoardNo = i
                gDeviceList.DeviceInfo(InfoIdx).BoardType = BoardType
                gDeviceList.DeviceInfo(InfoIdx).MemSize = MemSize
                InfoIdx = InfoIdx + 1
            End If
        Next

        cbxBoardNo.Items.Clear()
        For i As UInt16 = 0 To gDeviceList.BoardCount - 1
            cbxBoardNo.Items.Add(Convert.ToString(gDeviceList.DeviceInfo(i).BoardNo, 16))
        Next

        btnGetDeviceInfo.Enabled = False
        btnReadByte.Enabled = True
        btnWriteByte.Enabled = True
        btnReadWord.Enabled = True
        btnWriteWord.Enabled = True
        tbxAddress.Enabled = True
        tbxData.Enabled = True
        tbxRtnv.Enabled = True

        cbxBoardNo.SelectedIndex = 0
        cbxBoardNo.Enabled = True

        cbxBoardNo_SelectionChangeCommitted(Nothing, Nothing)


        'Dim Count As Integer = AW_GetDeviceInfo(gDeviceList)

        'If Count <= 0 Then
        '    Exit Sub
        'End If
        'Dim a As Byte
        'Dim ret As Integer
        'ret = AW_WriteByte(1, 0, 128)
        'ret = AW_ReadByte(1, 0, a)

    End Sub


    ' button ReadByte
    Private Sub btnReadByte_Click(sender As System.Object, e As System.EventArgs) Handles btnReadByte.Click
		'Dim Ret As Integer

		GetInputParam( FLG_READ_BYTE )

		gRet = AW_ReadByte( gBoardNo, gAddress, gBData )

		SetResultParam( FLG_READ_BYTE )

    End Sub

    ' button WriteByte
    Private Sub btnWriteByte_Click(sender As System.Object, e As System.EventArgs) Handles btnWriteByte.Click
		'Dim Ret As Integer

		GetInputParam( FLG_WRITE_BYTE )

		gRet = AW_WriteByte( gBoardNo, gAddress, gBData )

		SetResultParam( FLG_WRITE_BYTE )

    End Sub

    ' button ReadWord
    Private Sub btnReadWord_Click(sender As System.Object, e As System.EventArgs) Handles btnReadWord.Click
		'Dim Ret As Integer

		GetInputParam( FLG_READ_WORD )

		gRet = AW_ReadWord( gBoardNo, gAddress, gWData )

		SetResultParam( FLG_READ_WORD )

    End Sub

    ' button WriteWord
    Private Sub btnWriteWord_Click(sender As System.Object, e As System.EventArgs) Handles btnWriteWord.Click
		'Dim Ret As Integer

		GetInputParam( FLG_WRITE_WORD )

		gRet = AW_WriteWord( gBoardNo, gAddress, gWData )

		SetResultParam( FLG_WRITE_WORD )

    End Sub

    ' button Exit
    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    ' combobox BoadNo Selected
    Private Sub cbxBoardNo_SelectionChangeCommitted(sender As System.Object, e As System.EventArgs) Handles cbxBoardNo.SelectionChangeCommitted
        Dim i As Integer

        i = cbxBoardNo.SelectedIndex
        If i >= 0 Then
            Dim str As String
            Select Case gDeviceList.DeviceInfo(i).BoardType
                Case AW_TYPE_AP4801
                    str = "AP48-01"
                Case AW_TYPE_AP4802
                    str = "AP48-02"
                Case Else
                    str = "unknown"
            End Select
            lblBoardName.Text = str
        End If
        'lblAdrRange.Text = "0x0000-0x" & Convert.ToString(gDeviceList.DeviceInfo(i).MemSize, 16).PadLeft(4, "0")
        ' 本当は -1 なのだが...
        lblAdrRange.Text = "0x0000-0x" & gDeviceList.DeviceInfo(i).MemSize.ToString("X").PadLeft(4, "0")
    End Sub

	' Get Input Param
    Private Sub GetInputParam(Flg As UInteger)
        Dim i As Integer

        i = cbxBoardNo.SelectedIndex
        gBoardNo = gDeviceList.DeviceInfo(i).BoardNo

		If System.Text.RegularExpressions.Regex.IsMatch(tbxAddress.Text, "^[0-9A-Fa-f]+$") Then				' check input Text HEX
        	gAddress = Convert.ToUInt32(tbxAddress.Text, 16)
		Else
        	gAddress = 0
		End If
        'tbxAddress.Text = Convert.ToString(gAddress, 16).PadLeft(4, "0")
        tbxAddress.Text = gAddress.ToString("X").PadLeft(4, "0")

        If (Flg And FLG_READ_WRITE_MASK) = FLG_WRITE Then
            If (Flg And FLG_BYTE_WORD_MASK) = FLG_BYTE Then
				If System.Text.RegularExpressions.Regex.IsMatch(tbxData.Text, "^[0-9A-Fa-f]+$") Then		' check input Text HEX
                	gBData = Convert.ToByte(tbxData.Text, 16)
				Else
        			gBData = 0
				End If
                'tbxData.Text = Convert.ToString(gBData, 16).PadLeft(2, "0")
                tbxData.Text = gBData.ToString("X").PadLeft(2, "0")
            Else
				If System.Text.RegularExpressions.Regex.IsMatch(tbxData.Text, "^[0-9A-Fa-f]+$") Then		' check input Text HEX
                	gWData = Convert.ToUInt16(tbxData.Text, 16)
				Else
        			gWData = 0
				End If
                'tbxData.Text = Convert.ToString(gWData, 16).PadLeft(4, "0")
                tbxData.Text = gWData.ToString("X").PadLeft(4, "0")
            End If
        End If

    End Sub

    ' Set Result Param
    Private Sub SetResultParam(Flg As UInteger)

		tbxRtnv.Text = gRet.ToString()

        If (Flg And FLG_READ_WRITE_MASK) = FLG_READ Then
            If (Flg And FLG_BYTE_WORD_MASK) = FLG_BYTE Then
                'tbxData.Text = Convert.ToString(gBData, 16).PadLeft(2, "0")
                tbxData.Text = gBData.ToString("X").PadLeft(2, "0")
            Else
                'tbxData.Text = Convert.ToString(gWData, 16).PadLeft(4, "0")
                tbxData.Text = gWData.ToString("X").PadLeft(4, "0")
            End If
        End If

    End Sub

End Class
